Attribute VB_Name = "DataAccess"
Option Private Module
Option Explicit

Public Function Sources() As Scripting.Dictionary
  Set Sources = New Scripting.Dictionary
  Dim wData As Excel.Worksheet: Set wData = ThisWorkbook.Sheets(SHEET_SOURCES)
  Dim nRow&: nRow = FIRST_ROW
  Do While wData.Cells(nRow, S_SRC_ID) <> vbNullString
    Dim sFile$: sFile = wData.Cells(nRow, S_SRC_FILE).Text
    If Not Sources.Exists(sFile) Then _
      Call Sources.Add(sFile, wData.Cells(nRow, S_SRC_ID))
    nRow = nRow + 1
  Loop
End Function

Public Function SourceLocations() As Collection
  Set SourceLocations = New Collection
  
  Dim tData As Excel.ListObject: Set tData = ThisWorkbook.Worksheets(SHEET_PARAMS).ListObjects(TABLE_SOURCE_LOCATIONS)
  Dim dataRng As Excel.Range: Set dataRng = tData.Range
  Dim nRow&: nRow = FIRST_ROW
  For nRow = FIRST_ROW To dataRng.Rows.Count Step 1
    If dataRng.Cells(nRow, 1) <> vbNullString Then _
      Call SourceLocations.Add(dataRng.Cells(nRow, 1).Text)
  Next nRow
End Function

Public Function AddSource(sProject$, sFile$) As Long
  If sFile = vbNullString Then _
    Exit Function
    
  Dim wData As Excel.Worksheet: Set wData = ThisWorkbook.Sheets(SHEET_SOURCES)
  Dim nRow&: nRow = FIRST_ROW
  Do While wData.Cells(nRow, S_SRC_ID) <> vbNullString
    nRow = nRow + 1
  Loop
  AddSource = Application.WorksheetFunction.Max(wData.Columns(S_SRC_ID)) + 1
  wData.Cells(nRow, S_SRC_ID) = AddSource
  wData.Cells(nRow, S_SRC_PROJECT) = sProject
  wData.Cells(nRow, S_SRC_FILE) = sFile
  Dim hRange As Excel.Range: Set hRange = wData.Cells(nRow, S_SRC_FILE)
  Call hRange.Hyperlinks.Add(hRange, sFile)
End Function

Public Function AddTask(dDate As Double, sProject$, sText$, sResponsible$, nSource&, sFile$) As Long
  Dim wData As Excel.Worksheet: Set wData = ThisWorkbook.Sheets(SHEET_TASKS)
  Dim nRow&: nRow = FIRST_ROW
  Call wData.Rows(nRow).EntireRow.Insert(Shift:=xlShiftDown, CopyOrigin:=xlFormatFromRightOrBelow)

  AddTask = Application.WorksheetFunction.Max(wData.Columns(S_TASK_ID)) + 1
  wData.Cells(nRow, S_TASK_ID) = AddTask
  wData.Cells(nRow, S_TASK_STATUS) = T_TT_OPEN
  wData.Cells(nRow, S_TASK_PROJECT) = sProject
  wData.Cells(nRow, S_TASK_TEXT) = sText
  wData.Cells(nRow, S_TASK_RESPONSIBLE) = sResponsible
  wData.Cells(nRow, S_TASK_SOURCE_ID) = nSource
  wData.Cells(nRow, S_TASK_DATE) = IIf(dDate = 0, "", dDate)
  
  Dim hRange As Excel.Range: Set hRange = wData.Cells(nRow, S_TASK_SOURCE_ID)
  Call hRange.Hyperlinks.Add(hRange, sFile)
End Function
