Attribute VB_Name = "MainImpl"
Option Private Module
Option Explicit

Public Function ClearAll()
  Call ThisWorkbook.Sheets(SHEET_SOURCES).UsedRange.Offset(1, 0).ClearContents
  Call ThisWorkbook.Sheets(SHEET_TASKS).UsedRange.Offset(1, 0).ClearContents
End Function

Public Function ImportDataFrom(sFolder$, knownSources As Scripting.Dictionary) As Long
  Dim oFiles As Collection: Set oFiles = ListFiles(sFolder, WORD_MASK)
  Dim sFile As Variant
  Dim iScaner As New FileScaner: Call iScaner.Init
  For Each sFile In oFiles
    Dim sFullPath$: sFullPath = sFolder & "\" & CStr(sFile)
    If Not knownSources.Exists(sFullPath) Then _
      ImportDataFrom = ImportDataFrom + iScaner.Process(sFullPath)
  Next sFile
  Call iScaner.Finalize
End Function

' ====
Private Function ListFiles(sFolder$, sMask$) As Collection
  Set ListFiles = New Collection
  Dim sFile$: sFile = Dir(sFolder & "\" & sMask)
  Do While Len(sFile) > 0 And sFile <> sFolder
    Call ListFiles.Add(sFile)
    sFile = Dir
  Loop
End Function
