VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "s_DataAccess"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Function Setup()
  ' Mandatory setup function
End Function

Public Function Teardown()
  ' Mandatory teardown function
  Call ClearAll
End Function

Public Function t_Sources()
  On Error GoTo PROPAGATE_ERROR
  
  Call Dev_ExpectEQ(CSet(), Sources(), "Empty data")
  Call Dev_ExpectEQ(0, AddSource("proj1", ""), "Empty file")
  
  Dim iSources As New Scripting.Dictionary
  iSources("C:\Windows\file1.docx") = 1
  iSources("invalid path?") = 2
  iSources("C:\Windows\file2.docx") = 3
  
  Call Dev_ExpectEQ(1, AddSource("proj1", "C:\Windows\file1.docx"), "Add valid path")
  Call Dev_ExpectEQ(2, AddSource("proj1", "invalid path?"), "Add invalid path")
  Call Dev_ExpectEQ(3, AddSource("", "C:\Windows\file2.docx"), "Empty project")
  Call Dev_ExpectEQ(4, AddSource("proj2", "C:\Windows\file1.docx"), "Duplicate file")
  Call Dev_ExpectEQ(iSources, Sources(), "Valid data")
  Dim iCell As Excel.Range: Set iCell = ThisWorkbook.Sheets(SHEET_SOURCES).Cells(FIRST_ROW, S_SRC_FILE)
  Call Dev_ExpectEQ("C:\Windows\file1.docx", iCell.Hyperlinks(1).Address, "Add hyperlink")
  
  Call Dev_NewCase("Custom id")
  ThisWorkbook.Sheets(SHEET_SOURCES).Cells(FIRST_ROW, S_SRC_ID) = 100
  Call Dev_ExpectEQ(101, AddSource("proj3", "C:\Windows\file6.docx"))
  
  Exit Function
PROPAGATE_ERROR:
  Call Dev_LogError(Err.Number, Err.Description)
End Function

Public Function t_Tasks()
  On Error GoTo PROPAGATE_ERROR
  
  Dim iTasks As Excel.Worksheet: Set iTasks = ThisWorkbook.Sheets(SHEET_TASKS)
  
  Call Dev_NewCase("Valid add task")
  Call Dev_ExpectEQ(1, AddTask(100, "project", "text", "resp", 1337, "C:\Windows\file1.docx"))
  Call Dev_ExpectEQ(1, iTasks.Cells(FIRST_ROW, S_TASK_ID))
  Call Dev_ExpectEQ(100, iTasks.Cells(FIRST_ROW, S_TASK_DATE))
  Call Dev_ExpectEQ(T_TT_OPEN, iTasks.Cells(FIRST_ROW, S_TASK_STATUS))
  Call Dev_ExpectEQ("project", iTasks.Cells(FIRST_ROW, S_TASK_PROJECT))
  Call Dev_ExpectEQ("text", iTasks.Cells(FIRST_ROW, S_TASK_TEXT))
  Call Dev_ExpectEQ("resp", iTasks.Cells(FIRST_ROW, S_TASK_RESPONSIBLE))
  Call Dev_ExpectEQ(1337, iTasks.Cells(FIRST_ROW, S_TASK_SOURCE_ID))
  
  Call Dev_NewCase("Insert new to top")
  Call Dev_ExpectEQ(2, AddTask(101, "project2", "text2", "resp2", 13373, "C:\Windows\file2.docx"))
  Call Dev_ExpectEQ(2, iTasks.Cells(FIRST_ROW, S_TASK_ID))
  
  Exit Function
PROPAGATE_ERROR:
  Call Dev_LogError(Err.Number, Err.Description)
End Function
